{
------------------------------------------------------------------------------------------------------------
TSnapForm v1.3b - Copyright (C) 2003 (cyberbobjr & Emandhal)
30/06/2003
------------------------------------------------------------------------------------------------------------
Auteurs :
cyberbobjr - cyberbobjr@yahoo.com
M&'hal (Emandhal) - Hydrogene@netcourrier.com

Ce composant permet  une fiche de se magntiser  une autre fiche lors de son dplacement.
La force d'attraction est paramtrable.
Il est possible de coller les bords de l'cran
Il est galement possible de coller la fiche et faire dplacer la fille colle avec celle qui la colle.
------------------------------------------------------------------------------------------------------------
TSnapForm v1.4b - Composant non visuel
Correction de bugs :
  - Les changement de rsolutions et de surface MDI (resize de la ParentMDI) sont prises en compte
Amliorations :
  - Ajout d'vnements (1 pour la magntisation de fentres et 1 pour la magntisation de l'cran)
  - Ajout de la possibilite de dsactiver le magntisme sur certain bords de la Form

TSnapForm v1.3b - Composant non visuel
Correction de bugs :
  - La fiche ne se dcolle plus lorsque l'on l'a dplace trop vite
  - On peut activer le collage aprs la magntisation avec une prise d'effet immdiate

TSnapForm v1.2b - Composant non visuel
Amliorations :
  - Correction de bugs
  - Ajout de l'utilisation dans les MDI
  - Possibilite de coller les bords de l'cran (de mme dans les fentres MDI, on peut coller les bords de la surface visible)

Quelques bugs existent, en particulier :
  - Certainement dans la colle en particulier si la fiche sont colles par magntisme et que l'on active la colle, la colle ne prend pas..
    Il faut refaire la magntisation dans ce cas...

TSnapForm v0.9b - Composant non visuel
Quelques bugs existent, en particulier :
  - Lors d'un dplacement rapide et lorsque les fiches sont colles, la fiche se dcolle
  - Le collage disparait lorsqu'on min/max la fentre

------------------------------------------------------------------------------------------------------------
Quelques rappels :
  - Fiche magnetique : la fiche A est attire par la fiche B lorsque A est dplace prs de B
  - Fiche colle : la fiche A se dplace en mme temps que la fiche B lorsqu'elle est dplace

Dtails des proprits publie :
  Active : dtermine si la magntisation est active ou non (faux  la cration) - Boolen
  ActiveStick : Dtermine si on active le collage sur la fentre magntise - Boolen
  SnapStrenght : Dtermine la force de la magntisation - Integer
  SnapScreenBorder : Permet de dterminer la magntisation sur les bords de l'cran - Boolen

Dtails des fonctions :
    SetScreenRect; Enregistre la position des 4 coins de l'cran ou de la surface MDI visible dans FScreenRect
    WMMoving; Procdure apelle lors du dplacement de la fentre parente
    WMMovingStick; Procdure appele lors du dplacement de la fentre colle
    HookStickForm; Procdure initialisant la capture du message windows de dplacement de la fentre colle
    UnHookStickForm; Procdure supprimant la capture du message windows de dplacement de la fentre colle
    HookForm; Procdure initialisant la capture du message windows de dplacement de la fentre parente
    UnhookForm; Procdure supprimant la capture du message windows de dplacement de la fentre parente
    WndProcForm(var AMsg: TMessage); Gestion des messages de la fentre parente
    WndProcStickForm(var AMsg: TMessage); Gestion des messages de la fentre colle
    SetActive(value : boolean);  Procdure activant ou non la magntisation de la fentre parente
    SetStickActive(value : boolean); Procdure activant ou non le collage de la fentre magntise
    SetSnapScreenBorder(value : boolean); Procdure activant ou non le magntisme du bord de l'cran
    create(AOwner : TCOmponent); override; Constructeur du composant
    AddFormSnap(SnapForm : string); Ajoute une fiche pour la magntisation
    DelFormSnap(SnapForm : string); Supprime une fiche magntise
    Destroy; override; Destructeur
}
unit SnapForm;

interface

uses
  SysUtils, Classes, Forms, Messages, Types, Windows, Controls;

type
  TFormEdge = (feTop, feLeft, feRight, feBottom);

  TMagnetiseFormTo = set of TFormEdge; // Dtermine l'orientation de la magntisation de la Form
  TMagnetiseScreenTo = set of TFormEdge; // Dtermine l'orientation de la magntisation de l'cran

  TOnMagnetiseEvent = procedure (Sender : TObject; var EdgeMagnetise : TMagnetiseFormTo; var FormMagnetise : TForm) of object;
  TOnScreenMagnetiseEvent = procedure (Sender : TObject; var EdgeMagnetise : TMagnetiseScreenTo) of object;

  TSnapForm = class(TComponent)
  private
    FMagnetiseFormTo : TMagnetiseFormTo; // Dtermine l'orientation de la magntisation de la Form
    FMagnetiseScreenTo : TMagnetiseScreenTo; // Dtermine l'orientation de la magntisation de l'cran
    FOnMagnetiseEvent : TOnMagnetiseEvent; // Evenement de magntisation d'une Form
    FOnScreenMagnetiseEvent : TOnScreenMagnetiseEvent; // Evenement de magntisation de l'cran
    FActive : boolean; // Dtermine l'activation de la magntisation
    FStickActive : Boolean;  // Dtermine l'activation de la colle
    FFormParent : TForm; // Fiche propritaire du composant
    FStickForm : TForm; // Fiche en cours qui est colle  la fiche parent
    Fsticked : boolean; // La fiche est-elle colle ?
    FFormSnap : TList; // Liste des fiches magntisantes
    FSnapStrenght : integer; // force de la magntisation
    FSnapScreenBorder : boolean; // Dtermine si les bords de l'cran doivent tre magntiss
    FOldWindowProc: TWndMethod; // Pointeur pour sauvegarder l'ancienne gestion des messages de la fiche parent
    FOldStickWindowProc: TWndMethod;// Pointeur pour sauvegarder l'ancienne gestion des messages de la fiche colle
    FScreenRect: TRect; // Position des 4 coins de l'cran
    procedure SetScreenRect; //Enregistre la position des 4 coins de l'cran ou de la surface MDI visible dans FScreenRect
    procedure WMMoving(var Msg: TWMWindowPosMsg); message WM_WINDOWPOSCHANGING; // Procdure apelle lors du dplacement de la fentre parente
    procedure WMMovingStick(var Msg: TWMWindowPosMsg); // Procdure appele lors du dplacement de la fentre colle
    procedure HookStickForm; // Procdure initialisant la capture du message windows de dplacement de la fentre parente
    procedure UnHookStickForm; // Procdure supprimant la capture du message windows de dplacement de la fentre colle
    procedure HookForm; // Procdure initialisant la capture du message windows de dplacement de la fentre parente
    procedure UnhookForm; // Procdure supprimant la capture du message windows de dplacement de la fentre parente
    procedure WndProcForm(var AMsg: TMessage); // Gestion des messages de la fentre parente
    procedure WndProcStickForm(var AMsg: TMessage); // Gestion des messages de la fentre colle
    procedure SetActive(value : boolean); // Procdure activant ou non la magntisation de la fentre parente
    procedure SetStickActive(value : boolean); // Procdure activant ou non le collage de la fentre magntise
    procedure SetSnapScreenBorder(value : boolean); // Procdure activant ou non le magntisme du bord de l'cran
    function  IsOnlyInstance : Boolean; // Dtermine si le composant est seul sur la OwnerForm
    procedure RaiseMagnetiseEvent(EdgeMagnetise : TMagnetiseFormTo; FormMagnetise : TForm); // Procedure crant l'vnement de magntisation de la FormMagnetise
    procedure RaiseScreenMagnetiseEvent(EdgeMagnetise : TMagnetiseScreenTo); // Procedure crant l'vnement de magntisation de l'cran
    { Dclarations prives }
  protected
    { Dclarations protges }
  public
    constructor create(AOwner : TCOmponent); override;
    procedure AddFormSnap(SnapForm : TForm); // Ajoute une fiche pour la magntisation
    procedure DelFormSnap(SnapForm : TForm); // Supprime une fiche magntise
    function  CountFormSnap: Integer; // Renvoie le nombre de Forms  magntiser
    function  GetFormSnap(Pos : Integer): TForm; // Renvoie la Form situe  la position Pos de la liste FFormSnap
    destructor Destroy; override;
    { Dclarations publiques }
  published
    property MagnetiseFormTo : TMagnetiseFormTo read FMagnetiseFormTo write FMagnetiseFormTo default [feTop, feLeft, feRight, feBottom];
    property MagnetiseScreenTo : TMagnetiseScreenTo read FMagnetiseScreenTo write FMagnetiseScreenTo default [feTop, feLeft, feRight, feBottom];
    property Active : boolean read Factive write SetActive;
    property SnapStrenght : integer read FSnapStrenght write FSnapStrenght;
    property ActiveStick : boolean read FStickActive write SetStickActive;
    property SnapScreenBorder : boolean read FSnapScreenBorder write SetSnapScreenBorder;
    property OnMagnetise : TOnMagnetiseEvent read FOnMagnetiseEvent write FOnMagnetiseEvent;
    property OnScreenMagnetise : TOnScreenMagnetiseEvent read FOnScreenMagnetiseEvent write FOnScreenMagnetiseEvent;
    { Dclarations publies }
  end;

procedure Register;

implementation
// Enregistrement du composant dans la palette Exemples
procedure Register;
begin
  RegisterComponents('Exemples', [TSnapForm]);
end;

// Donne les coordonnes de la fentre du bureau ou de la MDI parente
procedure TSnapForm.SetScreenRect;
begin
  If FFormParent.FormStyle = fsMDIChild Then
    GetClientRect(Application.MainForm.ClientHandle, FScreenRect)
  else begin

    FScreenRect.Top    := screen.WorkAreaTop;
    FScreenRect.Left   := screen.WorkAreaLeft;
    FScreenRect.Bottom := screen.WorkAreaHeight; // Permet d'obtenir les coordonnes de la hauteur utile
    FScreenRect.Right  := screen.WorkAreaWidth;  // Permet d'obtenir les coordonnes de la largeur utile
{    FScreenRect.Top    := 1;
    FScreenRect.Left   := 1;
    FScreenRect.Right  := GetSystemMetrics(SM_CXFULLSCREEN);
    FScreenRect.Bottom := GetSystemMetrics(SM_CYFULLSCREEN);}
  end;
end;

// Dtermine si le composant est seul sur la OwnerForm
function TSnapForm.IsOnlyInstance: Boolean;
var
  z, Count : Integer;
begin
  Count:=0;
  for z:=0 to FFormParent.ComponentCount-1 do
    if FFormParent.Components[z] is TSnapForm then Inc(Count); // si un des composant de la FormParent est un TSnapForm alors on incrmente
  Result:=not Boolean(Count>1);
end;

// Procedure crant l'vnement de magntisation de la FormMagnetise
procedure TSnapForm.RaiseMagnetiseEvent(EdgeMagnetise : TMagnetiseFormTo; FormMagnetise : TForm);
begin
  if Assigned(OnMagnetise) then // Si un vnement est assign
    OnMagnetise(Self, EdgeMagnetise, FormMagnetise); // Alors on envoie les informations de magntisation
end;

// Procedure crant l'vnement de magntisation de l'cran
procedure TSnapForm.RaiseScreenMagnetiseEvent(EdgeMagnetise : TMagnetiseScreenTo);
begin
  if Assigned(OnScreenMagnetise) then // Si un vnement est assign
    OnScreenMagnetise(Self, EdgeMagnetise); // Alors on envoie les informations de magntisation
end;

// Positionne la proprit Active du collage
procedure TSnapForm.SetStickActive(Value : boolean);
begin
  FStickActive:=value;
  if value=true then
    begin
    HookStickForm; // Capture des messages de la fentre colle
    // L'instruction suivante permet de forcer le collage de la fentre, sinon il ne se fait pas
    // tant qu'il n'a pas recu un message windows de dplacement.
    SetWindowPos(FFormParent.Handle,0,FFormParent.Left,FFormParent.Top,0,0,(SWP_NOSIZE or SWP_NOZORDER));
    end
  else
    UnhookStickForm;
end;

// Positionne la proprit Active de la magntisation
procedure TSnapForm.SetActive(value : boolean);
begin
  if value=true then // Magntisation active ?
    HookForm // Si oui, on capture la fille des messages Windows sur la fentre parente
  else
    UnhookForm;  // Si non, on relache la capture des messages Windows sur la fentre parente
  Factive:=value;
end;

// Procdure activant ou non le magntisme du bord de l'cran
procedure TSnapForm.SetSnapScreenBorder(value : boolean);
begin
  SetScreenRect;
  FSnapScreenBorder:=value;
end;

// Paramtre SnapForm : nom de la fentre que l'on veut supprimer
procedure TSnapForm.DelFormSnap(SnapForm : TForm);
var
  z: Integer;
begin
  For z := 0 to FFormSnap.Count-1 do
    If AnsiCompareText(SnapForm.Name, TForm(FFormSnap[z]).Name)<>0 Then
      FFormSnap.Delete(z); // Recherche et supprime la fentre passe en paramtre
end;

// Procdure supprimant la capture du message windows de dplacement de la fentre colle
procedure TSnapForm.HookStickForm;
begin
  if csDesigning in ComponentState then     // Mode conception ?
    Exit; // Si oui, on sort

  if Assigned(FStickForm) and FStickForm.HandleAllocated then  // La fentre  coller est-elle dfinie ?
  begin
    if not (csDesigning in ComponentState) then // et si nous ne sommes pas en mode conception
    begin
      FOldStickWindowProc := FStickForm.WindowProc; // Alors on sauvegarde la fonction de gestion des messages de cette fentre
      FStickForm.WindowProc := WndProcStickForm; // Et on la remplace par la notre
      FSticked:=true; // La fentre est colle.
    end;
  end;
end;

// Procdure supprimant la capture du message windows de dplacement de la fentre colle
procedure TSnapform.UnhookStickForm;
begin
  if csDesigning in ComponentState then // Mode conception ?
    Exit; // si oui, on sort

  if (FStickForm <> nil) and (FStickForm.HandleAllocated) then // La fiche colle existe t'elle ?
    FStickForm.WindowProc := FOldStickWindowProc; // Si oui, on rtablit l'ancienne gestion des messages
  FOldStickWindowProc := nil; // On remet  zro les valeurs de collage
  FStickForm          := nil;
end;

// Procdure initialisant la capture du message windows de dplacement de la fentre parente
procedure TSnapform.HookForm;
begin
  if csDesigning in ComponentState then  // Mode conception ?
    Exit;  // si oui, on sort

  if Assigned(FFormParent) and FFormParent.HandleAllocated then
  begin
    if not (csDesigning in ComponentState) then
    begin
      FOldWindowProc         := FFormParent.WindowProc;  // Alors on sauvegarde la fonction de gestion des messages de cette fentre
      FFormParent.WindowProc := WndProcForm; // Et on la remplace par la notre
    end;
  end;
end;

procedure TSnapform.UnhookForm;
begin
  if csDesigning in ComponentState then  // Mode conception ?
    Exit; // si oui, on sort
    
  if (FFormParent <> nil) and (FFormParent.HandleAllocated) then  // La fiche parent est-elle dfinie ?
    FFormParent.WindowProc := FOldWindowProc; // Si oui, on restaure l'ancienne gestion des messages windows
  FOldWindowProc := nil; // On rinitialise les variables internes
//  FFormParent    := nil;
end;

// Procdure de gestion des messages windows d'une fentre colle, AMsg : Message windows
procedure TSnapForm.WndProcStickForm(var AMsg: TMessage);
begin
  if FStickActive then // Si l'option colle est active
  begin // Alors
    if AMsg.Msg=WM_WINDOWPOSCHANGING then // Si le message est WM_WINDOWPOSCHANGING (message genere lors d'un dplacement/resize/activation d'une fentre)
      WMMovingStick(TWMWindowPosMsg(AMsg)) // Alors on appelle notre procdure de dplacement+collage de fentre
    else
      FOldStickWindowProc(AMsg); // Sinon on appelle l'ancienne procdure de messages windows de la fentre
  end;
end;

// Procdure de gestion des messages windows de la fentre parent, AMsg : Message windows
procedure TSnapform.WndProcForm(var AMsg: TMessage);
begin
  if FActive then // Si l'option magntique est active
  begin // Alors
    if AMsg.Msg=WM_WINDOWPOSCHANGING then // Si le message est WM_WINDOWPOSCHANGING (message genere lors d'un dplacement/resize/activation d'une fentre)
      WMMoving(TWMWindowPosMsg(AMsg)); // Alors on appelle notre procdure de dplacement de la fentre parente
    if AMsg.Msg=WM_DISPLAYCHANGE Then // Si le message est pour un changement de rsolution
      SetScreenRect; // Alors on change les coordonnes de l'cran
  end;
  FOldWindowProc(AMsg); // Sinon on appelle l'ancienne procdure de messages windows de la fentre parente
end;

// Constructeur
constructor TSnapform.create(AOwner : TComponent);
begin
  inherited create(AOwner);
  if (AOwner is TForm) then // On s'assure que le parent est bien de type TForm
  begin
    SystemParametersInfo(SPI_SETDRAGFULLWINDOWS, Ord(true), nil, 0); // Paramtre systme permettant d'afficher le contenu de la fentre lors d'un dplacement
    FFormParent:=AOwner as TForm; // La fiche parente est propritaire du composant
    if IsOnlyInstance then // On s'assure que le composant est bien le seul sur la Form Parent
    begin
      FFormSnap:=TList.create; // On cre la liste devant contenir les fiches magntiques
      Factive:=false; // Le composant magntique n'est pas actif par dfaut
      FSticked:=false; // Le composant colle n'est pas actif par dfaut
      FSnapScreenBorder:=false; // La form ne colle pas les bords de l'cran par dfaut
      FMagnetiseFormTo:=[feTop, feLeft, feRight, feBottom]; // On active le magntisme sur tous les bords
      FMagnetiseScreenTo:=[feTop, feLeft, feRight, feBottom]; // On active le magntisme sur tous les bords
    end else Raise Exception.Create('Only one instance of TSnapForm is allowed per form.');
  end else Raise Exception.Create('TSnapForm can only be placed on a TForm.');
  FSnapStrenght:=20; // La force d'attraction est dfinie  20 pixels
  SetScreenRect; // Enregistre la position des bords de l'cran
end;

// Destructeur
destructor TSnapform.Destroy;
begin
  UnHookStickForm; // On remet toute les procdures de gestion messages d'origines
  UnhookForm;
  FFormSnap.Free;
  inherited Destroy;
end;

// Procdure appele lors du dplacement de la fentre colle
procedure TSnapForm.WMMovingStick(var Msg: TWMWindowPosMsg);
begin
  // Attention compliqu : si la fiche collante, l'option collante, fiche magnetise, et que ce ne soit pas un redimensionnenment sont activs
  if (assigned(FStickForm) and (FStickActive) and (FSticked) {and (Msg.WindowPos^.hwndInsertAfter=0)}) then
  begin
    // Si la fentre n'est pas resize mais dplace
    if ((Msg.WindowPos^.flags and SWP_NOMOVE)<>SWP_NOMOVE) and (Msg.WindowPos^.cx=FStickForm.width) and (Msg.WindowPos^.cy=FStickForm.height) then
      begin
      // Alors on modifie les coordonnes de la fiche parente pour reflter le delta de dplacement de la fiche collante
      // Mais auparavant on dsactive la procdure de gestion de la fentre colle
      UnhookForm;
      FFormParent.top:=FFormParent.top+(Msg.WindowPos^.y-FStickForm.Top){+(Msg.WindowPos^.cy-FStickForm.Height)};
      FFormParent.left:=FFormParent.left+(Msg.WindowPos^.x-FStickForm.left){+(Msg.WindowPos^.cx-FStickForm.Width)};
      // On ractive la procdure de gestion de la fentre colle
      HookForm;
      end
    else 
      begin
        if (Msg.WindowPos^.cy<>0) and (Msg.WindowPos^.cx<>0) then // Si elle est resize
          begin
          // Si la fiche est resiz du bas et que la fiche parente est en bas, on desticke
          if (Msg.WindowPos^.cy<>FStickForm.Height) and (Msg.WindowPos^.y=FStickForm.Top) and (FFormParent.Top=(FStickForm.Top+FStickForm.Height)) then
            FSticked:=false
          else
          // Idem pour le haut
          if (Msg.WindowPos^.cy<>FStickForm.Height) and (Msg.WindowPos^.y<>FStickForm.Top) and ((FFormParent.Top+FFormParent.Height)=FStickForm.Top) then
            Fsticked:=false
          else
          // Idem pour la droite
          if (Msg.WindowPos^.cx<>FStickForm.Width) and (Msg.WindowPos^.x=FstickForm.Left) and (FFormParent.Left=(FStickForm.Left+FStickForm.Width)) then
            Fsticked:=false
          else
          // Idem pour la gauche
          if (Msg.WindowPos^.cx<>FStickForm.Width) and (Msg.WindowPos^.x<>FstickForm.Left) and ((FFormParent.Left+FFormParent.Width=FStickForm.Left)) then
            FSticked:=false;
          end;
      end;
  end;
inherited;
end;


// Procdure appele lors du dplacement de la fentre parente
procedure TSnapForm.WMMoving(var Msg: TWMWindowPosMsg);
var
  FForm : TForm;
  FFormEdge : TMagnetiseFormTo;
  r, s : TRect; // Coordonnes de la fiche magntisante
  sticky : boolean; // La fiche est-elle colle ?
  Compteur : integer; // Nombre de fiches magntisantes dfinies dans le composant
begin
  if assigned(FFormSnap) then // Si la fiche parente est dfinie
  begin // alors
    sticky:=false; // Il n'y a plus de fentre colle
    with Msg.WindowPos^ do // Avec les coordonnes du message
    begin
      s.Left := x;
      s.Top := y;
      s.Right := x+FFormParent.Width;
      s.Bottom := y+FFormParent.Height;
    end;
    for Compteur:=0 to FFormSnap.Count-1 do // On rpte pour chaque fentre magntisante enregistre
    begin
      FFormEdge := [];
      FForm := TForm(FFormSnap[Compteur]); // on cre les coordonnes de la fiche magntisante
      r.Top := FForm.Top;
      r.Left := FForm.Left;
      r.Right := FForm.Left+FForm.Width;
      r.Bottom := FForm.Top+FForm.Height;
      // Si les coordonnes (x,y) de la fiche parente sont proches (de la force d'attraction) des coordonnes de la fiche magntisante alors
      // On dplace la fiche parente pour coller sur la fiche magnetisante
      // On en profite pour signaler par sticky que nous avons coll la fiche
      if feTop in FMagnetiseFormTo then
        if ((s.Top <= r.Bottom + FSnapStrenght) and (s.Top >= r.Bottom-FSnapStrenght)) and
           ((s.Right >= r.Left) and (s.Left <= r.Right)) then
        begin
          s.Top := r.Bottom;
          sticky:=true;
          FFormEdge := FFormEdge + [feTop];
        end;
      if feRight in FMagnetiseFormTo then
        if ((s.Right <= r.left + FSnapStrenght) and (s.Right >= r.left-FSnapStrenght)) and
           ((s.Bottom >= r.Top) and (s.Top <= r.Bottom)) then
        begin
          s.Left := r.left-FFormParent.Width;
          sticky:=true;
          FFormEdge := FFormEdge + [feRight];
        end;
      if feLeft in FMagnetiseFormTo then
        if ((s.Left >= r.right - FSnapStrenght) and (s.Left <= r.right+FSnapStrenght)) and
           ((s.Bottom >= r.Top) and (s.Top <= r.Bottom)) then
        begin
          s.Left := r.right;
          sticky:=true;
          FFormEdge := FFormEdge + [feLeft];
        end;
      if feBottom in FMagnetiseFormTo then
        if ((s.Bottom <= r.top + FSnapStrenght) and (s.Bottom >= r.top-FSnapStrenght)) and
           (s.Right >= r.Left) and (s.Left <= r.Right) then
        begin
          s.Top := r.top-FFormParent.Height;
          sticky:=true;
          FFormEdge := FFormEdge + [feBottom];
        end;
      with Msg.WindowPos^ do // Avec les coordonnes du message
      begin
        x := s.Left;
        y := s.Top;
      end;
      RaiseMagnetiseEvent(FFormEdge, FForm); // On envoi l'vnement
      if FStickActive then // Si l'option collage est active
      begin // Alors
      // Si il n'y a pas collage (sticky) mais que la fentre collante est dfinie
      // Cela veut dire que la fentre collante s'est dplace suffisamment pour dcoller la fiche parente
      // Donc on rtablit la gestion des messages de la fentre collante pour dcollerer ses dplacements
      // de la fentre parente
        if ((FStickForm<>nil) and (not sticky) and (Msg.WindowPos^.hwndInsertAfter=0)) then
          UnHookStickForm;
      // Si il y'a collage (sticky) et que la fentre collante n'est pas dfinie
      // Cela veut dire que la fentre parente vient de se coller  la fentre collante
      // Donc on capture les messages de la fentre collante pour rpercuter ses dplacements sur la
      // fentre parente
        if ((FStickForm=nil) and (sticky)) then
        begin
          FStickForm := TForm(FFormSnap[Compteur]);
          HookStickForm;
        end;
      end;
    end;
    if FSnapScreenBorder then
    begin
//      SetScreenRect; // On recalcule les bords de l'cran et de la Form au cas o il y ai eut un changement de rsolution ou un changement de la taille de la surface MDI
      FFormEdge := [];
      if feTop in FMagnetiseScreenTo then
        if (s.Top <= FScreenRect.Top+FSnapStrenght) and (s.Top >= FScreenRect.Top-FSnapStrenght) then
        begin
          s.Top := FScreenRect.Top;
          FFormEdge := FFormEdge + [feTop];
        end;
      if feLeft in FMagnetiseScreenTo then
        if (s.Left <= FScreenRect.Left+FSnapStrenght) and (s.Left >= FScreenRect.Left-FSnapStrenght) then
        begin
          s.Left := FScreenRect.Left;
          FFormEdge := FFormEdge + [feLeft];
        end;
      if feRight in FMagnetiseScreenTo then
        if (s.Right >= FScreenRect.Right-FSnapStrenght) and (s.Right <= FScreenRect.Right+FSnapStrenght) then
        begin
          s.Left := FScreenRect.Right-FFormParent.Width;
          FFormEdge := FFormEdge + [feRight];
        end;
      if feBottom in FMagnetiseScreenTo then
        if (s.Bottom >= FScreenRect.Bottom-FSnapStrenght) and (s.Bottom <= FScreenRect.Bottom+FSnapStrenght) then
        begin
          s.Top := FScreenRect.Bottom-FFormParent.Height;
          FFormEdge := FFormEdge + [feBottom];
        end;
      RaiseScreenMagnetiseEvent(FFormEdge);
    end;
    with Msg.WindowPos^ do // Avec les coordonnes du message
    begin
      x := s.Left;
      y := s.Top;
    end;
  end;
  inherited;
end;

// Ajoute la fentre dans la liste des fentres magntiques
procedure TSnapForm.AddFormSnap(SnapForm : TForm);
var
  z, Count: Integer;
begin
  Count:=0;
  For z := 0 to FFormSnap.Count-1 do
    If AnsiCompareText(SnapForm.Name, TForm(FFormSnap[z]).Name)=0 Then inc(Count);
  If Count > 0 Then Exit;
  FFormSnap.Add(Pointer(SnapForm));
end;

// Renvoie le nombre de Forms  magntiser
function TSnapForm.CountFormSnap: Integer;
begin
  result:=FFormSnap.Count;
end;

// Renvoie la Form situe  la position Pos de la liste FFormSnap
function TSnapForm.GetFormSnap(Pos : Integer): TForm;
begin
  result:=TForm(FFormSnap[Pos]);
end;

end.

